#MAG3_0P367 Patch Deployer for CVIX

# relaunch as an elevated process if not currently in administrator mode
if (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
    $PSHost = If ($PSVersionTable.PSVersion.Major -gt 5) {'PwSh'} else {'PowerShell'}
    Start-Process $PSHost -Verb RunAs "-NoProfile -ExecutionPolicy Bypass -Command `"cd '$($PWD.Path)'; & '$PSCommandPath' $servicePwd`"";
    Exit 
}

$prodVIX1 = @()
$prodVIX2 = @()
$prodVIX3 = @()
$prodVIX4 = @()
$prodVIX5 = @()

$prodALL = @()

$IOCVIX = @("vac10vixhie803.domain")

$Script:strCB = "OFF"

#Default menu
function Confirm-Default
{
    Write-Output  "*****************************************************************************"
    Write-Output  "This script applies MAG*3.0*367 Patch to be applied to CVIX."
    Do {$confirmDefaultOption = Read-Host "Confirm you want to proceed (Y), backout (B), (Q) to Quit, or (A) for Advanced"} while ($confirmDefaultOption -notmatch "Y|B|Q|A")

    switch ($confirmDefaultOption)
    {
        'Y' {'Local'
				$script:myComputer = $env:COMPUTERNAME
				$script:cvxEnv = "localhost"
				$script:cvxCnt = 1
				Write-Output $myComputer
				Get-TargetFileLocation $myComputer[0]
            }
		'B' {'Backout...'
			   	$script:myComputer = $env:COMPUTERNAME
				$script:cvxEnv = "localhost"
				$script:cvxCnt = 1
				Write-Output $myComputer
				$cred = ""
				Backout-Hotfix $myComputer $cred
            }
        'Q' {'Quitter...'
               Exit
            }
        'A' {'Entering advanced menu...'
              Create-Arrays
            }
    }
}

function Create-Arrays {
    
    $filePath = "C:\utils\vixscripts\vixsites.csv"
 
    $fileContent = Get-Content $filePath

    $prodVIX = @{}

    for ($i = 0; $i -lt $fileContent.Length; $i += 30) {
        $prodVIX[$i] += $fileContent[$i..($i + 29)]
    }

    $prodVIX1 = $prodVIX[0]
    $prodVIX2 = $prodVIX[30]
    $prodVIX3 = $prodVIX[60]
    $prodVIX4 = $prodVIX[90]
    $prodVIX5 = $prodVIX[120]

    $prodALL = $prodVIX1 + $prodVIX2 + $prodVIX3 + $prodVIX4 + $prodVIX5
    
    Show-EnvMenu
}

function Show-EnvMenu {

    if ($strCB -eq "ON") {
        Write-Host ""
        Write-Host "*** COWBOY MODE ON ***"
        Write-Host ""
    }

    Write-Host "========== Choose CVIX Environment =========="
    Write-Host "1: 01-30 PROD VIX"
    Write-Host "2: 31-60 PROD VIX"
    Write-Host "3: 61-90 PROD VIX"
    Write-Host "4: 91-120 PROD VIX"
    Write-Host "5: 121-149 PROD VIX"
    Write-Host "6: ALL PROD VIX"
    Write-Host "7: IOC VIX"
    Write-Host "`n0: TOGGLE COWBOY MODE (No confirmations)`n"

    Do {$CVIXEnv = Read-Host "Please choose CVIX environment (1-7 or Q to quit)"} while ($CVIXEnv -notmatch "1|2|3|4|5|6|7|Q|0")

    switch ($CVIXEnv)
    {
        '1' {'01-30 PROD VIX'
                $script:myComputer = $prodVIX1
                $script:cvxEnv = "01-30 PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '2' {'31-60 PROD VIX'
                $script:myComputer = $prodVIX2
                $script:cvxEnv = "31-60 PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '3' {'61-90 PROD VIX'
                $script:myComputer = $prodVIX3
                $script:cvxEnv = "61-90 PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '4' {'91-120 PROD VIX"'
                $script:myComputer = $prodVIX4
                $script:cvxEnv = "91-120 PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '5' {'121-149 PROD VIX'
                $script:myComputer = $prodVIX5
                $script:cvxEnv = "121-149 PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '6' {'ALL PROD VIX'
                $script:myComputer = $prodALL
                $script:cvxEnv = "ALL PROD VIX"
                $script:cvxCnt = $myComputer.count
            }
        '7' {'IOC VIX'
                $script:myComputer = $iocVIX
                $script:cvxEnv = "IOC VIX"
                $script:cvxCnt = $myComputer.count
            }
        '0' {'COWBOY MODE'
                if ($strCB -eq "OFF") {
                    $strCB = "ON"
                } else {
                    $strCB = "OFF"
                }
                Show-EnvMenu
            }
        'Q' {'quitter...'
                Exit
            }
    }

    Write-Output $myComputer

    $envConfirm = Read-Host -Prompt "Is this the correct environment (Y/N)?"

    if ($envConfirm -eq "Y")
    {
		$backOutConfirm= Read-Host -Prompt "Proceed with applying hotfix (Y) or proceed with backout (N)?"
		if  ($backOutConfirm -eq "Y")
		{
			Get-TargetFileLocation $myComputer[0]
		}
		else
		{
			if ($script:cvxEnv -ne "localhost")
			{
				$cred = Get-Credential
			}
			else
			{
				$cred = ""
			}
			
			foreach ($myServer in $myComputer)
			{
				Deploy-Hotfix $myServer $cred
			}	
		}
	
    } elseif ($envConfirm -eq "N") {
        Show-EnvMenu
    } else {
        Exit
    }
}

function Is-Host-Right-Patch {
    param ($sitevix)
    #Write-Output "********************"
    $varhttp = "http://$($sitevix):8080"
    #Write-Output $varhttp
    #Write-Output "Calling $($sitevix)"

    $progressPreference = 'silentlyContinue'

	$response = Invoke-WebRequest $varhttp -UseBasicParsing
                                   
	$progressPreference = 'continue'

	if ($response.Content -Match "348")
	{
		return $true;
	}
	else
	{
		return $false;
	}
}

function Select-LocalFileLocation {
    Write-Host "***********************************"
    Write-Host "*** Select Local File to Upload ***"

    Add-Type -AssemblyName System.Windows.Forms 
    $localFileBrowser = New-Object System.Windows.Forms.OpenFileDialog -Property @{ InitialDirectory = "C:\"
        Title = "Select File to Upload" }
    $null = $localFileBrowser.ShowDialog()
    $Script:localFileName = $localFileBrowser.FileName

    Write-Host "Local File Name: $($localFileName)"

    if ($($localFileName) -eq "") {
        Write-Host "You have not chosen a file to upload.  Exiting script."
        Exit
    } else {
        $Script:localFileNameOnly = Split-Path -Path $localFileName -leaf
        #get the hash
        $Script:localFileSHA = Get-FileHash $localFileName
        $localFileSHA = $localFileSHA.Hash

        Write-Host "File chosen:     $($localFileName)"
        Write-Host "  File name:     $($localFileNameOnly)"
        Write-Host "File SHA256:     $($localFileSHA)"
        Write-Host "***********************************"

        Confirm-Default
    }
}


function Get-TargetFileLocation {
	param($targetServer)
	
	$Script:targetFilePath = "C:\temp"

    Upload-TargetFile
}

function Upload-TargetFile {

	if ($script:cvxEnv -ne "localhost")
	{
		$cred = Get-Credential
	}
	else
	{
		$cred = ""
	}

    Do {$finalAnswer = Read-Host "Continue to update sites in $($myComputer) (Y/N)"} while ($finalAnswer -notmatch "Y|N")
    if ($finalAnswer -eq "Y")
    {
        foreach ($myServer in $myComputer)
		{
			$patchBool = Is-Host-Right-Patch $myServer

			if ($patchBool -eq $true)
			{
				Write-Output "Prompting for deployment on $myServer as on P348"
				Deploy-Hotfix $myServer $cred 					
			}
			else
			{
				Write-Output "Skiping $myServer as not on P348"
			}
					
        } #end foreach computer
    } elseif ($finalAnswer -eq "NO") {
       Write-Host "Aborting file transfer.  Exiting script."
       Exit 
    } 
}



function Backout-Hotfix {
    param($myServer, $cred)
	
	Write-Output "$myServer - Trying to esablish PS session..."
	if ($script:cvxEnv -ne "localhost")
	{
		$Session = New-PSSession -ComputerName $myServer -ErrorAction Continue -Credential $cred
	}
	else
	{
		$Session = New-PSSession -ComputerName $myServer -ErrorAction Continue
	}
    
	if ($Session.State -ne "Opened") {
        Write-Host "$myServer - Cannot establish PS session"

	} else {
		Write-Host "$myServer - Successfully establish PSSession, will be running command in PS session"
		
         ##############################
		 
		Write-Warning "** Working on $myServer **"
		if ($strCB -eq "ON")
		{
			$confirmBackOut = "Y"
		} else {
			$confirmBackOut = Read-Host -Prompt "Do you want to backout P367 Patch (Y/N)?"
		}
		if ($confirmBackOut -eq "Y")
		{
			##############################
			# Status of Tomcat service   #
			##############################
			Invoke-Command -Session $Session -ArgumentList $cvxEnv, $strCB, $myServer -ScriptBlock{
				param($cvxEnv, $strCB, $myServer)

				$tomcatname = "Tomcat9"
				$tomcatpid = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
				$tomcatstatus = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
				$tomcatstate = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
				Write-Output "***** Tomcat9 Service *****"
				Write-Output "Tomcat PID:  $tomcatpid"
				Write-Output $tomcatstatus
				Write-Output $tomcatstate			
			}
		
        
			##############################
			# Stopping Tomcat service    #
			##############################
			if ($strCB -eq "ON")
			{
				$confirmSvcStop = "Y"
			} else {
				$confirmSvcStop = Read-Host -Prompt "Do you want to stop the Tomcat9 service (Y/N)?"
			}
						
			if ($confirmSvcStop -eq "Y")
			{
				Invoke-Command -Session $Session -ArgumentList $cvxEnv, $strCB, $myServer -ScriptBlock{
					param($cvxEnv, $strCB, $myServer)

					$tomcatname = "Tomcat9"
					$tomcatpid = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
					$tomcatstatus = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
					$tomcatstate = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
					Write-Output "***** Tomcat9 Service *****"
					Write-Output "Tomcat PID:  $tomcatpid"
					Write-Output $tomcatstatus
					Write-Output $tomcatstate

					#check state
					#if "Running", proceed to shutdown. 
					if ($tomcatstate -eq 'Running') {
						Write-Output "$tomcatname service is running.  Stopping service..."
						$tomcatwait = 20 # number of seconds to wait for tomcat to stop before killing process	
						$tomcatBool = $true	
						$timespan = New-Object -TypeName System.Timespan -ArgumentList 0,0,$tomcatwait
						$svc = Get-Service -Name $tomcatname
						$svc.Stop()
						try {
							$svc.WaitForStatus([ServiceProcess.ServiceControllerStatus]::Stopped, $timespan)
						}
						catch [ServiceProcess.TimeoutException] {
							$tomcatBool = $false
						}
							
						if ($false -eq $tomcatBool)
						{
							Write-Output "tomcat service did not stop in $tomcatwait seconds, killing process."
							Stop-Process -Name "$tomcatname" -Force
						}
						else
						{
							Write-Output "verifying tomcat service did stop in $tomcatwait seconds."
						}
						#verifying service stopped
						Start-Sleep -s 10
						$tomcatstate2 = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
						Write-Output "$tomcatname is $tomcatstate2"
						if ($tomcatstate2 -eq 'Stopped') {
							Write-Output "Tomcat service successfully stopped."
						}
					}
				}
			}

			###################################################
			# Restoring files #
			###################################################
			if ($strCB -eq "ON")
			{
				$confirmRestore = "Y"
			} else {
				$confirmRestore = Read-Host -Prompt "Do you want to proceed with backing out the hotfix (Y/N)?"
			}
						
			if ($confirmRestore -eq "Y")
			{
				Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
					param($serverEnv, $strCB, $myServer)

					$varApacheWebAppsPath = "C:\Program Files\Apache Software Foundation\Tomcat 9.0\webapps"
					$varHotfixPath = "C:\temp\MAG3_0P367_Patch"
					$backupPattern = "Backup_\d{8}_\d{4}"
					$varBackupFolders = Get-ChildItem -Path $varHotfixPath -Directory | Where-Object {$_.Name -match $backupPattern}
					
					$newestBackupFolder = $varBackupFolders | Sort-Object -Property Name -Descending | Select-Object -First 1
					
					Write-Output "Found Backup Folder: $newestBackupFolder"
					Write-Output "Deleting original TIUWebApp folder from $varApacheWebAppsPath"
					Remove-Item -Path "$varApacheWebAppsPath\TIUWebApp" -Force -Recurse
					
					Write-Output "Restoring the P367 files to Tomcat webapps TIUWebApp folder."
					Copy-Item -Path "$varHotfixPath\$newestBackupFolder\TIUWebApp" -Destination $varApacheWebAppsPath -Recurse
				}
			}
      
			Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
				param($serverEnv, $strCB, $myServer)
				##############################
				# Update Version Page        #
				##############################		
				# Set the path to the XML file
				$vixConfigXMLPath = "C:\VixConfig\VixConfig.xml"
				$vixConfigXMLFile = [XML](Get-Content $vixConfigXMLPath)
				# Get the vixSoftwareVersion tag
				$vixSoftwareVersionTag = $vixConfigXMLFile.SelectNodes("//*[@property='vixSoftwareVersion']")[0]
				# Get the current value of the vixSoftwareVersion string
				$currentValue = $vixSoftwareVersionTag.InnerText
				if ($currentValue -eq "30.367.1.8230")
				{   #New value of the vixSoftwareVersion string intended for CVIX
					$newValue = "30.348.5.8228"
				}
				# Update the vixSoftwareVersion string
				$vixSoftwareVersionTag.InnerXml = "<string>$newValue</string>"			
				[System.Xml.XmlWriterSettings] $VixConfigXmlSettings = New-Object System.Xml.XmlWriterSettings
				#Preserve Windows formating
				$VixConfigXmlSettings.Indent = $true
				#Set encoding to UTF-8 without BOM
				$VixConfigXmlSettings.Encoding = New-Object System.Text.UTF8Encoding($false)
				[System.Xml.XmlWriter] $vixConfigXMLWriter = [System.Xml.XmlWriter]::Create($vixConfigXMLPath, $VixConfigXmlSettings)
				$vixConfigXMLFile.Save($vixConfigXMLWriter)
				#Close handle and flush
				$vixConfigXMLWriter.Dispose()
				Write-Output "DONE updating VIXConfig.xml"
                
                ##############################
				# Update VIX Install History #
				##############################
				$historyFile = 'C:\VixBackup\InstallHistory.txt'
				$myDateTime = Get-Date -Format "MM/dd/yyyy HH:mm"
				$myLine = $myDateTime + "|" + $env:UserName + "| Backout MAG3_0P367 Patch from " + $currentValue + " to " + $newValue
				Add-Content $historyFile $myLine
			}

			###############################
			# Starting Tomcat service #
			###############################
			if ($strCB -eq "ON")
			{
				$confirmSvcStart = "Y"
			} else {
				$confirmSvcStart = Read-Host -Prompt "Do you want to start the Tomcat9 Service (Y/N)?"
			}
						
			if ($confirmSvcStart -eq "Y")
			{
				Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
					param($serverEnv, $strCB, $myServer)

					$procname = "Tomcat9"

					$procpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty ProcessId
					$procstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty Status
					$procstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty State
					Write-Output "***** $procname Status *****"
					Write-Output "$procname PID:  $procpid"                        

					if ($procstate -eq 'Stopped') {
						Write-Output "$procname service is stopped.  Starting service..."
						Start-Service -Name "$procname"
						#verifying service started
						Start-Sleep -s 5
						$procstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty State
						Write-Output "$procname is $procstate2"

						if ($procstate2 -eq 'Running') {
							Write-Output "$procname service successfully started."
						}
					}
				}
			}
        Remove-PSSession -Session $Session
        }
    } #connection is good
}

function Deploy-Hotfix {
    param($myServer, $cred)
	
	Write-Output "$myServer - Trying to esablish PS session..."
	if ($script:cvxEnv -ne "localhost")
	{
		$Session = New-PSSession -ComputerName $myServer -ErrorAction Continue -Credential $cred
	}
	else
	{
		$Session = New-PSSession -ComputerName $myServer -ErrorAction Continue
	}
    
	if ($Session.State -ne "Opened") {
        Write-Host "$myServer - Cannot establish PS session"

	} else {
		Write-Host "$myServer - Successfully establish PSSession, will be running command in PS session"
		
         ##############################
		 
		 	Write-Warning "** Working on $myServer **"
		 
		 	##############################
			# File Copy   #
			##############################
		 
			$targetFileName = "$($targetFilePath)\$($localFileNameOnly)"
		 
		 	if ($strCB -eq "ON")
			{
				$confirmFileCopy = "Y"
			} else {
				$confirmFileCopy = Read-Host -Prompt "Do you want to copy the hotfix zip file (Y/N)?"
			}
			if ($confirmFileCopy -eq "Y")
			{
						
			Invoke-Command -Session $Session -ArgumentList $cvxEnv, $strCB, $myServer, $Script:targetFilePath, $Script:localFileNameOnly -ScriptBlock{
				param($cvxEnv, $strCB, $myServer, $targetFilePath, $localFileNameOnly)

					$targetFileName = "$($targetFilePath)\$($localFileNameOnly)"
					$targetFileBackup = "$($targetFileName)-fileupdate_" + (Get-Date -Format yyyyMMdd)

					Write-Host "target Folder:  $($targetFilePath)"
					Write-Host "  target File:  $($targetFileName)"

					Write-Host "Checking for target file existence."

					if (Test-Path -Path $targetFileName) {
						Write-Host "File exists, creating backup."
						Write-Host "Backup File:  $($targetFileBackup)"
						Copy-Item -Path $targetFileName -Destination $targetFileBackup
					} else {
						Write-Host "New file, no backup made."
					}
				}
				
				Copy-Item -Path "$($localFileName)" -Destination "$($targetFilePath)\$($localFileNameOnly)" -ToSession $Session -Force
			} 
				
              
        ##############################
        # Status of Tomcat service   #
        ##############################
        Invoke-Command -Session $Session -ArgumentList $cvxEnv, $strCB, $myServer -ScriptBlock{
            param($cvxEnv, $strCB, $myServer)

			$tomcatname = "Tomcat9"
			$tomcatpid = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
			$tomcatstatus = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
			$tomcatstate = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
			Write-Output "***** Tomcat9 Service *****"
			Write-Output "Tomcat PID:  $tomcatpid"
			Write-Output $tomcatstatus
			Write-Output $tomcatstate			
        }
		
        
        ##############################
        # Stopping Tomcat service    #
        ##############################
        if ($strCB -eq "ON")
        {
            $confirmSvcStop = "Y"
        } else {
            $confirmSvcStop = Read-Host -Prompt "Do you want to stop the Tomcat9 service (Y/N)?"
        }
                    
        if ($confirmSvcStop -eq "Y")
        {
            Invoke-Command -Session $Session -ArgumentList $cvxEnv, $strCB, $myServer -ScriptBlock{
                param($cvxEnv, $strCB, $myServer)

				$tomcatname = "Tomcat9"
				$tomcatpid = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
				$tomcatstatus = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
				$tomcatstate = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
				Write-Output "***** Tomcat9 Service *****"
				Write-Output "Tomcat PID:  $tomcatpid"
				Write-Output $tomcatstatus
				Write-Output $tomcatstate

				#check state
				#if "Running", proceed to shutdown. 
				if ($tomcatstate -eq 'Running') {
					Write-Output "$tomcatname service is running.  Stopping service..."
					$tomcatwait = 20 # number of seconds to wait for tomcat to stop before killing process	
					$tomcatBool = $true	
					$timespan = New-Object -TypeName System.Timespan -ArgumentList 0,0,$tomcatwait
					$svc = Get-Service -Name $tomcatname
					$svc.Stop()
					try {
						$svc.WaitForStatus([ServiceProcess.ServiceControllerStatus]::Stopped, $timespan)
					}
					catch [ServiceProcess.TimeoutException] {
						$tomcatBool = $false
					}
						
					if ($false -eq $tomcatBool)
					{
						Write-Output "tomcat service did not stop in $tomcatwait seconds, killing process."
						Stop-Process -Name "$tomcatname" -Force
					}
					else
					{
						Write-Output "verifying tomcat service did stop in $tomcatwait seconds."
					}
					#verifying service stopped
					Start-Sleep -s 10
					$tomcatstate2 = Get-CimInstance -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
					Write-Output "$tomcatname is $tomcatstate2"
					if ($tomcatstate2 -eq 'Stopped') {
						Write-Output "Tomcat service successfully stopped."
					}
				}
            }
        }


        ##########################
        # Unpack Hotfix Zip File #
        ##########################
        if ($strCB -eq "ON")
        {
            $confirmUnpack = "Y"
        } else {
            $confirmUnpack = Read-Host -Prompt "Do you want to unpack the hotfix zip file (Y/N)?"
        }
                    
        if ($confirmUnpack -eq "Y")
        {
            Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
                param($serverEnv, $strCB, $myServer)

                Write-Host "*** Unpacking hotfix zip file ***"

                $varHotfixPath = "C:\temp\MAG3_0P367_Patch"
                $varHotfixFile = "C:\temp\MAG3_0P367_Patch.zip"

                Expand-Archive $varHotfixFile -Force -DestinationPath $varHotfixPath
                
                Write-Host "Zip file successfully unpacked."
            }
        }


        ###################################################
        # Archiving existing files and Deploying new ones #
        ###################################################
        if ($strCB -eq "ON")
        {
            $confirmArchive = "Y"
        } else {
            $confirmArchive = Read-Host -Prompt "Do you want to proceed with applying the hotfix (Y/N)?"
        }
                    
        if ($confirmArchive -eq "Y")
        {
            Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
                param($serverEnv, $strCB, $myServer)

                $varApacheWebAppsPath = "C:\Program Files\Apache Software Foundation\Tomcat 9.0\webapps"
                $varHotfixPath = "C:\temp\MAG3_0P367_Patch"
                $varBackupPath = "$($varHotfixPath)\Backup_" + (Get-Date -Format yyyyMMdd_hhmm)
                
                Expand-Archive "$varHotfixPath\TIUWebApp.zip" -Force -DestinationPath "$varHotfixPath\TIUWebApp"
                
                Write-Output "Deleting original TIUWebApp folder from $varApacheWebAppsPath"
				New-Item -Path "$varApacheWebAppsPath\TIUWebApp" -ItemType Directory -Force
                Copy-Item -Path "$varApacheWebAppsPath\TIUWebApp" -Destination "$varBackupPath\TIUWebApp" -Recurse
                Remove-Item -Path "$varApacheWebAppsPath\TIUWebApp" -Force -Recurse
                
                Write-Output "Copying the fixed files to $varApacheWebAppsPath"
                Copy-Item -Path "$varHotfixPath\TIUWebApp" -Destination $varApacheWebAppsPath -Recurse
            }
        }
		
		Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
            param($serverEnv, $strCB, $myServer)
			##############################
			# Update Version Page        #
			##############################		
			# Set the path to the XML file
			$vixConfigXMLPath = "C:\VixConfig\VixConfig.xml"
			$vixConfigXMLFile = [XML](Get-Content $vixConfigXMLPath)
			# Get the vixSoftwareVersion tag
			$vixSoftwareVersionTag = $vixConfigXMLFile.SelectNodes("//*[@property='vixSoftwareVersion']")[0]
			# Get the current value of the vixSoftwareVersion string
			$currentValue = $vixSoftwareVersionTag.InnerText
			if ($currentValue -eq "30.348.5.8228")
			{
				# New value of the vixSoftwareVersion string intended for VIX
				$newValue = "30.367.1.8230"
			}
			# Update the vixSoftwareVersion string
			$vixSoftwareVersionTag.InnerXml = "<string>$newValue</string>"			
			[System.Xml.XmlWriterSettings] $VixConfigXmlSettings = New-Object System.Xml.XmlWriterSettings
			#Preserve Windows formating
			$VixConfigXmlSettings.Indent = $true
			#Set encoding to UTF-8 without BOM
			$VixConfigXmlSettings.Encoding = New-Object System.Text.UTF8Encoding($false)
			[System.Xml.XmlWriter] $vixConfigXMLWriter = [System.Xml.XmlWriter]::Create($vixConfigXMLPath, $VixConfigXmlSettings)
			$vixConfigXMLFile.Save($vixConfigXMLWriter)
			#Close handle and flush
			$vixConfigXMLWriter.Dispose()
			Write-Output "DONE updating VIXConfig.xml"
            
            ##############################
			# Update VIX Install History #
			##############################
			$historyFile = 'C:\VixBackup\InstallHistory.txt'
			$myDateTime = Get-Date -Format "MM/dd/yyyy HH:mm"
			$myLine = $myDateTime + "|" + $env:UserName + "| Updated from " + $currentValue + " to " + $newValue
			Add-Content $historyFile $myLine
		}

        ###############################
        # Starting Tomcat service #
        ###############################
        if ($strCB -eq "ON")
        {
            $confirmSvcStart = "Y"
        } else {
            $confirmSvcStart = Read-Host -Prompt "Do you want to start the Tomcat9 Service (Y/N)?"
        }
                    
        if ($confirmSvcStart -eq "Y")
        {
            Invoke-Command -Session $Session -ArgumentList $serverEnv, $strCB, $myServer -ScriptBlock{
                param($serverEnv, $strCB, $myServer)

                $procname = "Tomcat9"

	            $procpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty ProcessId
	            $procstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty Status
	            $procstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty State
	            Write-Output "***** $procname Status *****"
	            Write-Output "$procname PID:  $procpid"                        

	            if ($procstate -eq 'Stopped') {
		            Write-Output "$procname service is stopped.  Starting service..."
		            Start-Service -Name "$procname"
		            #verifying service started
		            Start-Sleep -s 5
		            $procstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$procname'" | Select-Object -ExpandProperty State
		            Write-Output "$procname is $procstate2"

		            if ($procstate2 -eq 'Running') {
			            Write-Output "$procname service successfully started."
		            }
	            }
            }
        }

        Remove-PSSession -Session $Session
           
    } #connection is good
}

Select-LocalFileLocation

Write-Warning "** SCRIPT COMPLETE **"